#include <Wire.h>  //Нужна для переделки аналоговых ввводов A4 A5 в SDA SCL
#include <LiquidCrystal_PCF8574.h>

#define VoltmeterPin 14 //A0
#define relle1 2 //вывод управления релле
#define relle2 3
#define relle3 4
#define relle4 5
#define PIN_PHOTO_SENSOR 16 //A2
#define minlumen 50

void UpdateDisplay (byte DopFunct = 0);

int Napruga = 230; //Расчётное напряжение (реальное)
int TmpV = 230;  //Напряжение снятое с датчика
int PredCheckNapr = Napruga;  //Предыдущее напряжение смены статуса
byte RellePosit = 0;
byte PredelUderjzaniya = 6;
int counter = -1;
int SleepStartDef = 5; //секунд задержки перед запуском
int SleepStart = SleepStartDef; 
boolean StatRelle1 = 0; //статус релле ВЫКЛ
boolean WarningStatus = 0; // на грани переключения статуса
boolean Backlight = 1;
int SmenaStatRelleDef = 10; //10 сек на задержку если скачет напруга
int SmenaStatRelle = SmenaStatRelleDef;
int lumen = minlumen + 1; //датчик света
byte Prosadka = 0;
int MinV = 230;

LiquidCrystal_PCF8574 lcd(0x27); // Вариант для библиотеки PCF8574 

void setup() {
  //Serial.begin(9600);
  pinMode(relle1, OUTPUT); //релле
  pinMode(relle2, OUTPUT);
  pinMode(relle3, OUTPUT);
  pinMode(relle4, OUTPUT);
  digitalWrite(relle1, HIGH); //Релле вык. ко умолчанию
  digitalWrite(relle2, HIGH);
  digitalWrite(relle3, HIGH);
  digitalWrite(relle4, HIGH);

  lcd.begin(16, 2);                     // Инициализация дисплея  
  lcd.setBacklight(true);               // Подключение подсветки
  lcd.clear();
  SleepStart -=1;
}

void loop() {
//Napruga = 230;
Napruga = TekNapr();
 counter += 1;
 delay(1); //стопарим алгоритм на 1 мсек
 if (((counter % 10) == 0)&&(SleepStart==SleepStartDef)) { // Цикл 10 мс
  if ((Napruga>140)&&(Napruga<280)) { if (StatRelle1==0) digitalWrite(relle1, LOW); StatRelle1 = 1;}
    else { StatRelle1 = 0; digitalWrite(relle1, HIGH); SleepStart -=1;}
  CheckVoltage(Napruga);
 }
if ((counter % 1000) == 0) { // Цикл 1000 мс
  counter =0;
  if (SleepStart<SleepStartDef) {SleepStart -=1; }
  if (SleepStart < 0) {
      SleepStart = SleepStartDef;
      UpdateDisplay(1); //очистить строку 2
      }
  if (SmenaStatRelle<SmenaStatRelleDef) SmenaStatRelle -= 1; //Задержка смены статуса релле на случай, если скачет напруга
  if (SmenaStatRelle <= 0) {
    SmenaStatRelle = SmenaStatRelleDef;
    UpdateDisplay(1);   //Как вышла задержка - очистить отсчёт на дисплее
    }
  if (TekSvet()<minlumen) {if (Backlight == 1) lcd.setBacklight(false); Backlight = 0;} 
    else if (Backlight == 0) {lcd.setBacklight(true); Backlight=1;}
  UpdateDisplay(0);
 }
  
}

int TekNapr(){
  TmpV = (TmpV*9+(analogRead(VoltmeterPin)*0.322))/10; //Напряжение в розетке делим на показания analogRead() чтобы узнать коэфиц.
  if (TmpV>265) return TmpV-5; //устраняем плавоющую погрешность
  if (TmpV>255) return TmpV-4;
  if (TmpV>245) return TmpV-3;
  if (TmpV>235) return TmpV-2;
  if (TmpV>200) return TmpV;
  if (TmpV>195) return TmpV+2;
  if (TmpV>175) return TmpV+4;
  if (TmpV>165) return TmpV+5;
  if (TmpV>155) return TmpV+6;
  if (TmpV>150) return TmpV+7;
  return TmpV+8;
}

int TekSvet(){
  int byf = analogRead(PIN_PHOTO_SENSOR); 
  if (byf>minlumen) byf = minlumen*2.9; //выводим среднее арифм. по свету, чтобы сгладить показания датчика
  lumen = (lumen*4+byf)/5;
  return lumen;
  }
  
void UpdateDisplay (byte DopFunct = 0){
switch (DopFunct) {
    case 1:
      lcd.setCursor(0,1);
      lcd.print("                ");
      break;
  }
  lcd.setCursor(0,0);
  lcd.print("Input ");
  lcd.print(Napruga);
  lcd.print("v");
  
  if (SleepStart!=SleepStartDef) {
    lcd.setCursor(0,1);
    lcd.print("Sleep: ");
    lcd.setCursor(7,1);
    lcd.print("     ");
    lcd.setCursor(7,1);
    lcd.print(SleepStart);
  } else if (SmenaStatRelle!=SmenaStatRelleDef) {
    lcd.setCursor(0,1);
    lcd.print("Freez: ");
    lcd.setCursor(7,1);
    lcd.print("   ");
    lcd.setCursor(7,1);
    lcd.print(SmenaStatRelle);
  }
  if (WarningStatus) {
    lcd.setCursor(12,0);    
    lcd.print("!");
    lcd.print(abs(Napruga-PredCheckNapr));
    lcd.print("v");    
    } else {
    lcd.setCursor(12,0);
    lcd.print("    ");      
    }
  if (MinV<200) {
    lcd.setCursor(9,1);
    lcd.print("min ");
    lcd.print(MinV);
    } else {
    lcd.setCursor(9,1);
    lcd.print("        ");      
    }
    
}

void CheckVoltage (int Napr) {
//  Serial.println(Napr);
  byte Posit = 0;
  if (Napr>140) {Posit = 6;}
  if (Napr>160) {Posit = 5;}
  if (Napr>180) {Posit = 4;}
  if (Napr>200) {Posit = 3;}
  if (Napr>225) {Posit = 2;} //Прямой режим. Что на входе, то и на выходе.
  if (Napr>245) {Posit = 1;}
  if ((abs(RellePosit-Posit) == 1)&&(abs(Napruga-PredCheckNapr)<=PredelUderjzaniya)) { 
    //Если хотим сменить статус/напругу, но пред. напруга отличается от текущей всего на PredelUderjzaniya вольт, то не меняем статус.
    WarningStatus = 1;
    return 0;
  } else if (WarningStatus) {WarningStatus = 0;}
  if ((abs(RellePosit-Posit) == 1)&&(SmenaStatRelle!=SmenaStatRelleDef)) { return 0;} 
  if ((Posit>RellePosit)&&(Prosadka == 0)) Prosadka +=1;  // еслу есть кратковременная просадка, то не поникуем, ждём 150 мс
  if (Prosadka > 0) {
    Prosadka +=1;
    if (MinV>Napr) MinV=Napr;    
    if (Prosadka >= 15) {Prosadka = 0;}
      else return 0;
    }   
  switch (Posit) {
    case 1:
      if (RellePosit!=1) SetVoltage(1,1,1); 
      RellePosit = 1;
      break;
    case 2:
      if (RellePosit!=2) SetVoltage(0,1,1);
      RellePosit = 2;
      break;
    case 3:
      if (RellePosit!=3) SetVoltage(1,0,0); 
      RellePosit = 3;
      break;
    case 4:
      if (RellePosit!=4) SetVoltage(0,0,0); 
      RellePosit = 4;
      break;
    case 5:
      if (RellePosit!=5) SetVoltage(1,0,1); 
      RellePosit = 5;
      break;
    case 6:
      if (RellePosit!=6) SetVoltage(0,0,1); 
      RellePosit = 6;
      break;
  }

}

void SetVoltage(boolean RL2, boolean RL3, boolean RL4) {
  SmenaStatRelle -= 1;
  PredCheckNapr = Napruga;   
  if (RL3) {digitalWrite(relle3, LOW);} else {digitalWrite(relle3, HIGH);}
  if (RL4) {digitalWrite(relle4, LOW);} else {digitalWrite(relle4, HIGH);}
  delay(100); //бережём релле от залипания, переключаем группами. Сперва вход, затем выход.
  if (RL2) {digitalWrite(relle2, LOW);} else {digitalWrite(relle2, HIGH);}  
}
